/*
 *
 * apps/videoServer/VideoClient.H --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#ifndef VideoClient_H
#define VideoClient_H

#include "Notifier.H"

#include <nucleo/core/ReactiveObject.H>

#include <nucleo/utils/ConfigDict.H>
#include <nucleo/network/tcp/TcpConnection.H>
#include <nucleo/network/http/HttpMessage.H>
#include <nucleo/image/source/ImageSource.H>
#include <nucleo/image/sink/ImageSink.H>

using namespace nucleo ;

class VideoClient : public ReactiveObject {

protected:

  TcpConnection *connection ;
  ImageSource *source ;
  Image img ;
  ImageSink *sink ;

  void react(Observable *) ;

public:

  VideoClient(ConfigDict &serverConfig, TcpConnection *connection) ;
  ~VideoClient(void) ;

} ;

#endif
