#ifndef n_cTimeKeeper_H
#define n_cTimeKeeper_H

/*
 *
 * nucleo/core/carbon/cTimeKeeper.H --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/core/TimeKeeper.H>

#include <Carbon/Carbon.H>

namespace nucleo {

  // ---------------------------------------------------------------

  class cTimeKeeper : public TimeKeeper {

  protected:

    bool _repeat ;
    EventLoopTimerRef _timerId ;

    unsigned long _epoch, _millisecs ;

    friend class TimeKeeper ;

    cTimeKeeper(void) {}
    static void _callback(EventLoopTimerRef timerId, void *) ;

  public:

    ~cTimeKeeper() ;

    void arm(unsigned long milliseconds, bool repeat=false) ;
    long getTimeLeft(void) ; // in milliseconds
    void disarm(void) ;

  } ;

  // ---------------------------------------------------------------

}

#endif
