#ifndef n_howlServiceAnnouncer_H
#define n_rdvServiceAnnouncer_H

/*
 *
 * nucleo/plugins/howl/howlServiceAnnouncer.H --
 *
 * Copyright (C) Nicolas Roussel
 *
 * See the file LICENSE for information on usage and redistribution of
 * this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 */

#include <nucleo/network/rdv/Service.H>
#include <nucleo/network/rdv/ServiceAnnouncer.H>

#include <nucleo/plugins/howl/howlKeeper.H>

#include <discovery/text_record.h>

namespace nucleo {

  class howlServiceAnnouncer : public ServiceAnnouncer {

  private:

    bool autorename ;

    char *name, *type, *domain, *host ;
    int port ;
    sw_text_record text_record ;

    sw_discovery_oid	id ;
    sw_discovery_publish_status status ;

    static sw_result
    saServiceReply(sw_discovery discovery,
			    sw_discovery_publish_status status,
			    sw_discovery_oid id,
			    sw_opaque extra) ;

    void announce(void) ;

  public:

    // domain defaults to ".local", host to the machine running the application
    howlServiceAnnouncer(const char *name, const char *type, int port,
					TextRecords *textRecords=0,
					bool autorename=true,
					const char *domain=0, const char *host=0) ;

    state getState(void) ;
    bool changeName(const char *newname=0) ;
    std::string getName(void) ;
 
    ~howlServiceAnnouncer(void) ;

  } ;

}

#endif
